# mypy-boto3-secretsmanager

[![PyPI - mypy-boto3-secretsmanager](https://img.shields.io/pypi/v/mypy-boto3-secretsmanager.svg?color=blue)](https://pypi.org/project/mypy-boto3-secretsmanager)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-secretsmanager.svg?color=blue)](https://pypi.org/project/mypy-boto3-secretsmanager)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-secretsmanager](#mypy-boto3-secretsmanager)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.SecretsManager 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/secretsmanager.html#SecretsManager) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-secretsmanager](#mypy-boto3-secretsmanager)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `SecretsManager` service.

```bash
python -m pip install boto3-stubs[secretsmanager]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_secretsmanager` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_secretsmanager import SecretsManagerClient

# Now mypy can check if your code is valid.
client: SecretsManagerClient = boto3.client("secretsmanager")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: SecretsManagerClient = session.client("secretsmanager")



# Annotated paginators are included as well

import mypy_boto3_secretsmanager.paginator as secretsmanager_paginators

list_secrets_paginator: secretsmanager_paginators.ListSecretsPaginator = client.get_paginator("list_secrets")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_secretsmanager` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_secretsmanager as secretsmanager
from mypy_boto3_secretsmanager import SecretsManagerClient

# with these
from mypy_boto3 import secretsmanager
from mypy_boto3.secretsmanager import SecretsManagerClient
```